### Summary

Underworld is an open-source, parallel, particle-in-cell, finite element geodynamics code [1,2,3]. Please refer to repository
top level `README.md` for further information. 

### Licensing

1) All Underworld source code is released under the LGPL-3 (See LGPLv3.txt). This covers all
files `underworld` constituting the Underworld Python library, and any other material not explicitly identified under (2) below.

2) Notebooks, stand-alone documentation and Python scripts which show how the code is used and run are licensed under the Creative Commons Attribution 4.0 International License. To view a copy of this license, visit http://creativecommons.org/licenses/by/4.0/ or send a letter to Creative Commons, PO Box 1866, Mountain View, CA 94042, USA.  We offer this licence to encourage you to modify and share the examples and use them to help you in your research. Where no individual creator is identified in these files, the appropriate attribution is "The Underworld Team". All the files covered by this license are found in the `UserGuide` directory.

### History

Underworld has been in development since 2003. It has always been released under open-source license with the copyright held by the organisations contributing to its development. The underworld team has changed considerably during that time. For detailed information on the individuals and organisations contributing to the code, it is necessary to consult the repository history data and commit logs. Historical information beyond that found within the current repository is available upon request.

### Copyright holders

Copyright Australian National University, 2020-2022
Copyright Melbourne University,           2014-2021
Copyright Monash University,              2003-2021
Copyright VPAC,                           2003-2009

### References

   1. Moresi, L.N., Dufour, F., Muhlhaus, H.B., 2003. A Lagrangian integration point finite element method for large deformation modeling of viscoelastic geomaterials. Journal of Computational Physics 184, 476–497.

   2. Moresi, L. N., S. Quenette, V. Lemiale, C. Mériaux, B. Appelbe, and H. B. Muhlhaus (2007), Computational approaches to studying non-linear dynamics of the crust and mantle, Physics of the Earth and …, 163(1-4), 69–82, doi:10.1016/j.pepi.2007.06.009.

   3. Quenette, S., Moresi, L.N., Sunter, P.D., Appelbe, W.F., 2007. Explaining StGermain: An aspect oriented environment for building extensible computational mechanics modeling software, in:. Presented at the HIPS 2007 Workshop, Parallel and Distributed Processing Symposium, 2007. Proceedings. 19th IEEE International.
